;Przykładowy program POOL, możesz go dowolnie
;używać i modyfikować na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

include "elastic.l

to model :xy
  use elastic :xy

  setti "yellow_ball
  setpc {10 0 50 10}
  setr 8

  to onsignalstep :turtle :data
    if :running && :speed > 0 [fd :speed * :data,2]
  end
end

shared "running
make "running false
bounce ;kulki będą odbijać się od ścian

;pozycje żółtych kulek:
make "p {{0 0}
  {-30 25} {30 25}
  {-60 50} {0 50} {60 50}
  {-90 75} {-30 75} {30 75} {90 75}
  {-120 100} {-60 100} {0 100} {60 100} {120 100}
  {-150 125} {-90 125} {-30 125} {30 125} {90 125} {150 125}}

make "t [] ;lista żółtych kulek
foreach "pi :p [queue :t (newt $model :pi)]
;kulka uderzająca pozostałe:
make "u (newt $model {0 -100})
(setti "default) @ :u
;(setmass 20) @ :u ;*** może być cięższa od innych ***

make "ltxt label "Ekin [160 12 50 24]
make "lval label 0 [210 12 160 24]
make "hit 0
tto :u
ht

to onmousemove :mousepos
  if not :running [
    let "h (towards :mousepos) @ :u
    (seth :h + 180) @ :u
    make "hit (int (distance :u :mousepos)) / 200
    settext :lval 0.5 * (:mass @ :u) * :hit^2
  ]
end

to onmouseclick
  if not :running [
    (setspeed :hit) @ :u
    make "running true
  ]
end

make "tick (timer "step 20 100)

;zatrzymuje kulki:
make "stop (button "Stop {20 12 70 24} [
  make "running false
  (setspeed 0) @ :t ;uruchom na zbiorze żółwi
  (setspeed 0) @ :u ;uruchom na jednym żółwiu
])

;sprawdza sumę energii kulek:
make "check timer [
  if :running && :iter % 3 = 0 [
    let "ek ekin @ :u
    let "e ekin @ :t
    foreach "ei :e ["ek += :ei]
    settext :lval :ek
  ]
] 1000

